Index: squid/src/win32.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/win32.c,v
retrieving revision 1.1.2.2
retrieving revision 1.1.2.3
diff -u -r1.1.2.2 -r1.1.2.3
--- squid/src/win32.c	25 Mar 2001 16:42:23 -0000	1.1.2.2
+++ squid/src/win32.c	14 Jun 2001 20:36:16 -0000	1.1.2.3
@@ -1,18 +1,65 @@
+/*
+ * $Id$
+ *
+ * * * * * * * * Legal stuff * * * * * * *
+ *
+ * (C) 2001 Guido Serassio <serassio@libero.it>,
+ *   inspired by previous work by Romeo Anghelache & Eric Stern.
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *  
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
 #include "squid.h"
 
-static int s_iInitCount = 0;
+/* This code compiles only CygWin & Windows NT Port */
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#include <windows.h>
+
+static unsigned int GetOSVersion();
+void WIN32_svcstatusupdate(DWORD);
+void WINAPI WIN32_svcHandler(DWORD);
+static int WIN32_StoreKey(const char *, DWORD, unsigned char *, int);
+static int WIN32_create_key(void);
+void WINAPI SquidMain(DWORD, char **);
+/* The following code section is part of an EXPERIMENTAL native */
+/* Windows NT/2000 Squid port - Compiles only on MS Visual C++  */
+#if defined(_SQUID_MSWIN_)
+static int Win32SockInit(void);
+static void Win32SockCleanup(void);
+#endif /* End native Windows NT EXPERIMENTAL PORT */
+
+static SERVICE_STATUS svcStatus;
+static SERVICE_STATUS_HANDLE svcHandle;
+
 #define VENDOR   "GNU"
+#if defined(_SQUID_MSWIN_)
 #define SOFTWARE "SquidNT"
-#define VERSION  "2.3Stable4"
+#else
+#define SOFTWARE "Squid"
+#endif
+#define VERSION  "2.3-STABLE-4"
 #define REGKEY "SOFTWARE\\" VENDOR "\\" SOFTWARE "\\" VERSION
-TCHAR servname[512]=SQUID_SERVICE_NAME;
 
-SERVICE_STATUS svcStatus;
+/* ====================================================================== */
+/* LOCAL FUNCTIONS */
+/* ====================================================================== */
 
-int create_key(void)
+static int
+WIN32_create_key(void)
 {
-    static char *keys[] = 
-    { "SOFTWARE",
+    static char *keys[] = { "SOFTWARE",
 	VENDOR,
 	SOFTWARE,
 	VERSION,
@@ -31,225 +78,505 @@
     /* Walk the tree, creating at each stage if necessary */
     while (keys[index]) {
 	unsigned long result;
-
-	rv = RegCreateKeyEx(hKey,
-			    keys[index], /* subkey */
-			    0,	         /* reserved */
-			    NULL,        /* class */
-			    REG_OPTION_NON_VOLATILE,
-			    KEY_WRITE,
-			    NULL,
-			    &hKeyNext,
-			    &result);
+	rv = RegCreateKeyEx(hKey, keys[index],	/* subkey */
+	    0,			/* reserved */
+	    NULL,		/* class */
+	    REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKeyNext, &result);
 	if (rv != ERROR_SUCCESS) {
-	    debug(1,1)("RegCreateKeyEx(%s),%d\n", keys[index],rv);
+	    debug(1, 1) ("RegCreateKeyEx(%s),%d\n", keys[index], rv);
 	    retval = -4;
 	}
-
 	/* Close the old key */
 	rv = RegCloseKey(hKey);
 	if (rv != ERROR_SUCCESS) {
-	    debug(1,1)("RegCloseKey %d\n", rv);
+	    debug(1, 1) ("RegCloseKey %d\n", rv);
 	    if (retval == 0) {
 		/* Keep error status from RegCreateKeyEx, if any */
-		retval = -4;  
+		retval = -4;
 	    }
 	}
-
 	if (retval) {
 	    break;
 	}
-
 	hKey = hKeyNext;
 	index++;
     }
-
     if (keys[index] == NULL) {
 	/* Close the final key we opened, if we walked the entire
 	 * tree
 	 */
 	rv = RegCloseKey(hKey);
 	if (rv != ERROR_SUCCESS) {
-	    debug(1,1)("RegCloseKey %d\n", rv);
+	    debug(1, 1) ("RegCloseKey %d\n", rv);
 	    if (retval == 0) {
 		/* Keep error status from RegCreateKeyEx, if any */
-		retval = -4;  
+		retval = -4;
 	    }
 	}
     }
-
     return retval;
 }
 
-int store_key(const char *key, DWORD type, unsigned char *value, int value_size)
+static int
+WIN32_StoreKey(const char *key, DWORD type, unsigned char *value,
+    int value_size)
 {
     long rv;
     HKEY hKey;
     int retval;
 
-    rv = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
-		      REGKEY,
-		      0,
-	 	      KEY_WRITE,
-		      &hKey);
-
+    rv = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY, 0, KEY_WRITE, &hKey);
     if (rv == ERROR_FILE_NOT_FOUND) {
 	/* Key could not be opened -- try to create it 
 	 */
-	if (create_key() < 0) {
+	if (WIN32_create_key() < 0) {
 	    /* Creation failed (error already reported) */
 	    return -4;
 	}
-	
 	/* Now it has been created we should be able to open it
 	 */
-	rv = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
-		  REGKEY,
-		  0,
-	 	  KEY_WRITE,
-		  &hKey);
-
+	rv = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY, 0, KEY_WRITE, &hKey);
 	if (rv == ERROR_FILE_NOT_FOUND) {
-	    debug(1,1)("Registry does not contain key %s after creation",REGKEY );
+	    debug(1, 1) ("Registry does not contain key %s after creation",
+		REGKEY);
 	    return -1;
 	}
     }
-
     if (rv != ERROR_SUCCESS) {
-	debug(1,1)("RegOpenKeyEx HKLM\\%s, %d\n", REGKEY,rv);
+	debug(1, 1) ("RegOpenKeyEx HKLM\\%s, %d\n", REGKEY, rv);
 	return -4;
     }
-
     /* Now set the value and data */
-    rv = RegSetValueEx(hKey, 
-		       key,	/* value key name */
-		       0,	/* reserved */
-		       type,	/* type */
-		       value,	/* value data */
-		       (DWORD)value_size); /* for size of "value" */
-
-    retval = 0;	    /* Return value */
-
+    rv = RegSetValueEx(hKey, key,	/* value key name */
+	0,			/* reserved */
+	type,			/* type */
+	value,			/* value data */
+	(DWORD) value_size);	/* for size of "value" */
+    retval = 0;			/* Return value */
     if (rv != ERROR_SUCCESS) {
-	debug(1,1)("RegQueryValueEx(key %s),%d\n",key,rv);
+	debug(1, 1) ("RegQueryValueEx(key %s),%d\n", key, rv);
 	retval = -4;
+    } else {
+	debug(1, 1) ("Registry stored HKLM\\%s\\%s value %s\n",
+	    REGKEY,
+	    key,
+	    type == REG_SZ ? value : (unsigned char *) "(not displayable)");
     }
-    else {
-	debug(1,1)("Registry stored HKLM\\%s\\%s value %s\n",
-		REGKEY, 
-		key,
-		type == REG_SZ ? value : (unsigned char*)"(not displayable)");
-    }
-
     /* Make sure we close the key even if there was an error storing
      * the data
      */
     rv = RegCloseKey(hKey);
     if (rv != ERROR_SUCCESS) {
-	debug(1,1)("RegCloseKey HKLM\\%s, %d\n", REGKEY,rv);
+	debug(1, 1) ("RegCloseKey HKLM\\%s, %d\n", REGKEY, rv);
 	if (retval == 0) {
 	    /* Keep error status from RegQueryValueEx, if any */
-	    retval = -4;  
+	    retval = -4;
 	}
     }
-
     return retval;
 }
 
-void RemoveService()
+static unsigned int
+GetOSVersion()
 {
-    SC_HANDLE   schService;
-    SC_HANDLE   schSCManager;
-    schSCManager = OpenSCManager(
-                        NULL,                   // machine (NULL == local)
-                        NULL,                   // database (NULL == default)
-                        SC_MANAGER_ALL_ACCESS   // access required
-                        );
-    if (!schSCManager) debug(1,1)("OpenSCManager failed");
-    else {
-        schService = OpenService(schSCManager, servname, SERVICE_ALL_ACCESS);
+    OSVERSIONINFO osvi;
+
+    xfree(WIN32_OS_string);
+    memset(&osvi, '\0', sizeof(OSVERSIONINFO));
+    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
+    GetVersionEx((OSVERSIONINFO *) & osvi);
+    switch (osvi.dwPlatformId) {
+    case VER_PLATFORM_WIN32_NT:
+	if (osvi.dwMajorVersion <= 4) {
+	    WIN32_OS_string=xstrdup("Windows NT");
+	    return _WIN_OS_WINNT;
+	}
+	if (osvi.dwMajorVersion == 5) {
+	    WIN32_OS_string=xstrdup("Windows 2000");
+	    return _WIN_OS_WIN2K;
+	}
+	break;
+    case VER_PLATFORM_WIN32_WINDOWS:
+	if ((osvi.dwMajorVersion > 4) ||
+	    ((osvi.dwMajorVersion == 4) && (osvi.dwMinorVersion > 0))) {
+	    WIN32_OS_string=xstrdup("Windows 98");
+	    return _WIN_OS_WIN98;
+	}
+	WIN32_OS_string=xstrdup("Windows 95");
+	return _WIN_OS_WIN95;
+	break;
+    case VER_PLATFORM_WIN32s:
+	WIN32_OS_string=xstrdup("Windows 3.1 with WIN32S");
+	return _WIN_OS_WIN32S;
+	break;
+    default:
+	return _WIN_OS_UNKNOWN;
+    }
+    WIN32_OS_string=xstrdup("Unknown");
+    return _WIN_OS_UNKNOWN;
+}
 
-        if (schService == NULL) debug(1,1)("OpenService failed");
-            /* Could not open the service */
-        else {
-            /* try to stop the service */
-            if (ControlService(schService, SERVICE_CONTROL_STOP, &svcStatus)) {
-                Sleep(1000);
-                while(QueryServiceStatus(schService, &svcStatus)) {
-                    if(svcStatus.dwCurrentState == SERVICE_STOP_PENDING)
-                        Sleep(1000);
-                    else
-                        break;
-                }
-            }
+/* ====================================================================== */
+/* PUBLIC FUNCTIONS */
+/* ====================================================================== */
 
-            // now remove the service
-            if (DeleteService(schService) == 0) debug(1,1)("DeleteService failed");
-			else printf("Service %s deleted successfuly, see ya'round :)\n", SQUID_SERVICE_NAME);
+VOID
+WIN32_Exit(int ExitStatus)
+{
+#ifdef _SQUID_MSWIN_
+    Win32SockCleanup();
+#endif
+#ifdef USE_WIN32_SERVICE
+    if (ExitStatus) {
+	svcStatus.dwWin32ExitCode = ERROR_SERVICE_SPECIFIC_ERROR;
+	svcStatus.dwServiceSpecificExitCode = 1;
+    }
+    svcStatus.dwCurrentState = SERVICE_STOPPED;
+    SetServiceStatus(svcHandle, &svcStatus);
+#endif
+    exit(0);
+}
 
-            CloseServiceHandle(schService);
-        }
+int
+WIN32_Subsystem_Init()
+{
+    WIN32_OS_version = GetOSVersion();
+#ifdef USE_WIN32_SERVICE
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) {
+	char path[512];
+	HKEY hndKey;
+	/* Register the service Handler function */
+	svcHandle =
+	    RegisterServiceCtrlHandler(WIN32_Service_name,
+	    WIN32_svcHandler);
+	if (svcHandle == 0)
+	    return 1;
+	/* Set Process work dir to directory cointaining squid.exe */
+	GetModuleFileName(NULL, path, 512);
+	path[strlen(path) - 10] = '\0';
+	if (SetCurrentDirectory(path) == 0)
+	    return 1;
+	xfree(ConfigFile);
+	/* get config file from Windows Registry */
+	if (RegOpenKey(HKEY_LOCAL_MACHINE, REGKEY, &hndKey) == ERROR_SUCCESS) {
+	    DWORD Type = 0;
+	    DWORD Size = 0;
+	    LONG Result;
+	    Result =
+		RegQueryValueEx(hndKey, WIN32_Service_name, NULL, &Type, NULL, &Size);
+	    if (Result == ERROR_SUCCESS && Size) {
+		ConfigFile = xmalloc(Size);
+		RegQueryValueEx(hndKey, WIN32_Service_name, NULL, &Type, ConfigFile,
+		    &Size);
+	    } else
+		ConfigFile = xstrdup(DefaultConfigFile);
+	    RegCloseKey(hndKey);
+	} else {
+	    ConfigFile = xstrdup(DefaultConfigFile);
+	}
+	/* Set Service Staus to SERVICE_START_PENDING */
+	svcStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
+	svcStatus.dwCurrentState = SERVICE_START_PENDING;
+	svcStatus.dwControlsAccepted =
+	    SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
+	svcStatus.dwWin32ExitCode = 0;
+	svcStatus.dwServiceSpecificExitCode = 0;
+	svcStatus.dwCheckPoint = 0;
+	svcStatus.dwWaitHint = 10000;
+	SetServiceStatus(svcHandle, &svcStatus);
+    }
+#endif
+#ifdef _SQUID_MSWIN_
+    Win32SockInit();
+#endif
+    return 0;
+}
 
-        CloseServiceHandle(schSCManager);
+#ifdef USE_WIN32_SERVICE
+void
+WIN32_svcstatusupdate(DWORD svcstate)
+{
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) {
+	svcStatus.dwCheckPoint++;
+	svcStatus.dwCurrentState = svcstate;
+	SetServiceStatus(svcHandle, &svcStatus);
     }
+}
 
+VOID WINAPI
+WIN32_svcHandler(DWORD Opcode)
+{
+    DWORD status;
+
+    switch (Opcode) {
+    case _WIN_SQUID_SERVICE_CONTROL_STOP:
+    case _WIN_SQUID_SERVICE_CONTROL_SHUTDOWN:
+/* Do whatever it takes to stop here. */
+	svcStatus.dwWin32ExitCode = 0;
+	svcStatus.dwCurrentState = SERVICE_STOP_PENDING;
+	svcStatus.dwCheckPoint = 0;
+	svcStatus.dwWaitHint = 10000;
+	shut_down(SIGTERM);
+	if (!SetServiceStatus(svcHandle, &svcStatus)) {
+	    status = GetLastError();
+	    debug(1, 1) (" SetServiceStatus error  %ld\n", status);
+	}
+	debug(1, 1) ("Leaving Squid service \n");
+	return;
+    case _WIN_SQUID_SERVICE_CONTROL_INTERROGATE:
+/* Fall through to send current status. */
+	if (!SetServiceStatus(svcHandle, &svcStatus)) {
+	    status = GetLastError();
+	    debug(1, 1) (" SetServiceStatus error  %ld\n", status);
+	}
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_ROTATE:
+	rotate_logs(SIGUSR1);
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_RECONFIGURE:
+	reconfigure(SIGHUP);
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_DEBUG:
+	sigusr2_handle(SIGUSR2);
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_INTERRUPT:
+/* Do whatever it takes to stop here. */
+	svcStatus.dwWin32ExitCode = 0;
+	svcStatus.dwCurrentState = SERVICE_STOP_PENDING;
+	svcStatus.dwCheckPoint = 0;
+	svcStatus.dwWaitHint = 10000;
+	shut_down(SIGINT);
+	if (!SetServiceStatus(svcHandle, &svcStatus)) {
+	    status = GetLastError();
+	    debug(1, 1) (" SetServiceStatus error  %ld\n", status);
+	}
+	debug(1, 1) ("Leaving Squid service \n");
+	break;
+    default:
+	debug(1, 1) ("Unrecognized opcode %ld\n", Opcode);
+    }
+    return;
 }
 
-void InstallService()
+void
+WIN32_RemoveService()
 {
-    SC_HANDLE   schService;
-    SC_HANDLE   schSCManager;
+    SC_HANDLE schService;
+    SC_HANDLE schSCManager;
 
-    TCHAR szPath[512];
-	int lenpath;
-    if ((lenpath=GetModuleFileName( NULL, szPath, 512 )) == 0)
-    {
-        exit(1);
-        return;
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    schSCManager = OpenSCManager(NULL,	/* machine (NULL == local)    */
+	NULL,			/* database (NULL == default) */
+	SC_MANAGER_ALL_ACCESS	/* access required            */
+	);
+    if (!schSCManager)
+	debug(1, 1) ("OpenSCManager failed");
+    else {
+	schService = OpenService(schSCManager, WIN32_Service_name, SERVICE_ALL_ACCESS);
+	if (schService == NULL)
+	    debug(1, 1) ("OpenService failed");
+	/* Could not open the service */
+	else {
+	    /* try to stop the service */
+	    if (ControlService(schService, _WIN_SQUID_SERVICE_CONTROL_STOP,
+		    &svcStatus)) {
+		Sleep(1000);
+		while (QueryServiceStatus(schService, &svcStatus)) {
+		    if (svcStatus.dwCurrentState == SERVICE_STOP_PENDING)
+			Sleep(1000);
+		    else
+			break;
+		}
+	    }
+	    /* now remove the service */
+	    if (DeleteService(schService) == 0)
+		fprintf(stderr,"DeleteService failed.\n");
+	    else
+		printf("Service %s deleted successfully.\n",
+		    WIN32_Service_name);
+	    CloseServiceHandle(schService);
+	}
+	CloseServiceHandle(schSCManager);
     }
+}
 
-    schSCManager = OpenSCManager(
-                        NULL,                   // machine (NULL == local)
-                        NULL,                   // database (NULL == default)
-                        SC_MANAGER_ALL_ACCESS   // access required
-                        );
-   if (!schSCManager) debug(1,1)("OpenSCManager failed");
+void
+WIN32_InstallService()
+{
+    SC_HANDLE schService;
+    SC_HANDLE schSCManager;
+    char ServicePath[512];
+    char szPath[512];
+    int lenpath;
+    
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    if ((lenpath = GetModuleFileName(NULL, ServicePath, 512)) == 0) {
+	debug(1, 1) ("Can't get executable path");
+	exit(1);
+    }
+    snprintf(szPath, sizeof(szPath), "%s %s:%s", ServicePath, _WIN_SQUID_SERVICE_OPTION, WIN32_Service_name);
+    schSCManager = OpenSCManager(NULL,	/* machine (NULL == local)    */
+	NULL,			/* database (NULL == default) */
+	SC_MANAGER_ALL_ACCESS	/* access required            */
+	);
+    if (!schSCManager) {    
+	debug(1, 1) ("OpenSCManager failed");
+	exit(1);
+    }
     else {
-        schService = CreateService(
-            schSCManager,               // SCManager database
-            servname,        // name of service
-            servname, // name to display
-            SERVICE_ALL_ACCESS,         // desired access
-            SERVICE_WIN32_OWN_PROCESS,  // service type
-            SERVICE_AUTO_START,       // start type
-            SERVICE_ERROR_NORMAL,       // error control type
-            (const char*)szPath,                     // service's binary
-            NULL,                       // no load ordering group
-            NULL,                       // no tag identifier
-            NULL,       // dependencies
-            NULL,                       // LocalSystem account
-            NULL);                      // no password
-
-        if (schService) {
-            CloseServiceHandle(schService);
-
-	    /* Now store the server_root in the registry */
-	    store_key("ServerRoot", REG_SZ,(unsigned char*) szPath, lenpath+1);
-		printf("Service %s installed successfuly, enjoy :)\n", SQUID_SERVICE_NAME);
-		printf("that is, u may start it from the Services applet of control panel\n");
-		printf("Don't forget to edit squid.conf before starting it\n\n");
-		printf("Romeo Anghelache, http://www.andrew.cmu.edu/~romeo/ \n");
-		printf("Guido Serassio, http://serassio.interfree.it \n");
-		printf("No warranties of any kind, no time for support!\n");
-		printf("This work derived from GNU Squid2.3 stable 4\n");
-        }
-        else  debug(1,1)("CreateService failed");
+	schService = CreateService(schSCManager,	/* SCManager database     */
+	    WIN32_Service_name,		/* name of service        */
+	    WIN32_Service_name,		/* name to display        */
+	    SERVICE_ALL_ACCESS,	/* desired access         */
+	    SERVICE_WIN32_OWN_PROCESS,	/* service type           */
+	    SERVICE_AUTO_START,	/* start type             */
+	    SERVICE_ERROR_NORMAL,	/* error control type     */
+	    (const char *) szPath,	/* service's binary       */
+	    NULL,		/* no load ordering group */
+	    NULL,		/* no tag identifier      */
+	    "Tcpip\0Afd\0",		/* dependencies           */
+	    NULL,		/* LocalSystem account    */
+	    NULL);		/* no password            */
+	if (schService) {
+	    CloseServiceHandle(schService);
+	    /* Now store the config file location in the registry */
+	    if (!ConfigFile)
+		ConfigFile = xstrdup(DefaultConfigFile);
+	    WIN32_StoreKey(WIN32_Service_name, REG_SZ, (unsigned char *) ConfigFile, strlen(ConfigFile) + 1);
+	    printf("Squid Cache version %s for %s\n", version_string,
+		CONFIG_HOST_TYPE);
+	    printf("installed successfully as %s Windows System Service.\n",
+		WIN32_Service_name);
+	    printf
+		("To run, start it from the Services Applet of Control Panel.\n");
+	    printf("Don't forget to edit squid.conf before starting it.\n\n");
+	} else {
+	    debug(1, 1) ("CreateService failed");
+	    exit(1);
+	}
+	CloseServiceHandle(schSCManager);
+    }
+}
+
+void
+WIN32_sendSignal(int WIN32_signal)
+{
+    SERVICE_STATUS ssStatus;
+    DWORD fdwAccess, fdwControl;
+    SC_HANDLE schService;
+    SC_HANDLE schSCManager;
+
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    schSCManager = OpenSCManager(NULL,	/* machine (NULL == local)    */
+	NULL,			/* database (NULL == default) */
+	SC_MANAGER_ALL_ACCESS	/* access required            */
+	);
+    if (!schSCManager) {
+	debug(1, 1) ("OpenSCManager failed");
+	exit(1);
+    }
+    /* The required service object access depends on the control. */
+    switch (WIN32_signal) {
+    case 0:			/* SIGNULL */
+	fdwAccess = SERVICE_INTERROGATE;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_INTERROGATE;
+	break;
+    case SIGUSR1:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_ROTATE;
+	break;
+    case SIGUSR2:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_DEBUG;
+	break;
+    case SIGHUP:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_RECONFIGURE;
+	break;
+    case SIGTERM:
+	fdwAccess = SERVICE_STOP;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_STOP;
+	break;
+    case SIGINT:
+    case SIGKILL:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_INTERRUPT;
+	break;
+    default:
+	exit(1);
+    }
+    /* Open a handle to the service. */
+    schService = OpenService(schSCManager,	/* SCManager database */
+	WIN32_Service_name,	/* name of service    */
+	fdwAccess);		/* specify access     */
+    if (schService == NULL) {
+	fprintf(stderr, "%s: ERROR: Could not open Service %s\n", appname,
+	    WIN32_Service_name);
+	exit(1);
+    } else {
+	/* Send a control value to the service. */
+	if (!ControlService(schService,	/* handle of service      */
+		fdwControl,	/* control value to send  */
+		&ssStatus)) {	/* address of status info */
+	    fprintf(stderr, "%s: ERROR: Could not Control Service %s\n",
+		appname, WIN32_Service_name);
+	    exit(1);
+	} else {
+	    /* Print the service status. */
+	    printf("\nStatus of %s Service:\n", WIN32_Service_name);
+	    printf("  Service Type: 0x%lx\n", ssStatus.dwServiceType);
+	    printf("  Current State: 0x%lx\n", ssStatus.dwCurrentState);
+	    printf("  Controls Accepted: 0x%lx\n", ssStatus.dwControlsAccepted);
+	    printf("  Exit Code: %ld\n", ssStatus.dwWin32ExitCode);
+	    printf("  Service Specific Exit Code: %ld\n",
+		ssStatus.dwServiceSpecificExitCode);
+	    printf("  Check Point: %ld\n", ssStatus.dwCheckPoint);
+	    printf("  Wait Hint: %ld\n", ssStatus.dwWaitHint);
+	}
+	CloseServiceHandle(schService);
+    }
+    CloseServiceHandle(schSCManager);
+}
 
-        CloseServiceHandle(schSCManager);
+int main(int argc, char **argv)
+{
+    SERVICE_TABLE_ENTRY DispatchTable[] = {
+	{NULL, SquidMain},
+	{NULL, NULL}
+    };
+    char *c;
+    
+    if ((argc == 2) && strstr(argv[1], _WIN_SQUID_SERVICE_OPTION)){
+	WIN32_run_mode = _WIN_SQUID_RUN_MODE_SERVICE;
+	if (!(c=strchr(argv[1],':'))){
+	    fprintf(stderr, "Bad Service Parameter: %s\n", argv[1]);
+	    return 1;
+	}
+	WIN32_Service_name = xstrdup(c+1);
+	DispatchTable[0].lpServiceName=WIN32_Service_name;
+    	if (!StartServiceCtrlDispatcher(DispatchTable)) {
+	    fprintf(stderr, "StartServiceCtrlDispatcher error = %ld\n",
+		GetLastError());
+	    return 1;
+	}
+    } else {
+    	WIN32_run_mode = _WIN_SQUID_RUN_MODE_INTERACTIVE;
+	SquidMain(argc, argv);
     }
+    return 0;
 }
+#endif
+
+/* The following code section is part of an EXPERIMENTAL native */
+/* Windows NT/2000 Squid port - Compiles only on MS Visual C++  */
+
+#if defined(_SQUID_MSWIN_)
+static int s_iInitCount = 0;
 
-int Win32SockInit(void)
+static int Win32SockInit(void)
 {
     int iVersionRequested;
     WSADATA wsaData;
@@ -261,7 +588,6 @@
     }
     else if (s_iInitCount < 0)
 	return (s_iInitCount);
-
     /* s_iInitCount == 0. Do the initailization */
     iVersionRequested = MAKEWORD(2, 0);
     err = WSAStartup((WORD) iVersionRequested, &wsaData);
@@ -275,16 +601,16 @@
 	WSACleanup();
 	return (s_iInitCount);
     }
-	debug(1,1)("Windows sockets initialised");
+    debug(1,1)("Windows sockets initialised");
     s_iInitCount++;
     return (s_iInitCount);
-
 }
 
-
-void Win32SockCleanup(void)
+static void Win32SockCleanup(void)
 {
     if (--s_iInitCount == 0)
 	WSACleanup();
     return;
 }
+#endif /* End native Windows NT EXPERIMENTAL PORT */
+#endif
